"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Canvas = void 0;
var _reactNativeSkia = require("@shopify/react-native-skia");
var _react = _interopRequireWildcard(require("react"));
var _reactNativeGestureHandler = require("react-native-gesture-handler");
var _reactNativeReanimated = require("react-native-reanimated");
var _context = require("./context");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const Canvas = _ref => {
  let {
    children,
    panGesture = _reactNativeGestureHandler.Gesture.Pan(),
    timeoutBeforeCollectingRefs = 100,
    ...props
  } = _ref;
  // Instead of value, provide a subscribe method and reload the refs
  const touchableRefs = (0, _react.useMemo)(() => {
    return {
      value: {}
    };
  }, []);
  const activeKey = (0, _reactNativeReanimated.useSharedValue)([]);

  // This must be improved, it's a hack to wait for the refs to be loaded
  const [loadedRefs, prepareLoadedRefs] = (0, _react.useState)({});
  const ref = (0, _react.useRef)();
  (0, _react.useEffect)(() => {
    ref.current = setTimeout(() => {
      prepareLoadedRefs(touchableRefs.value);
    }, timeoutBeforeCollectingRefs);
    return () => {
      clearTimeout(ref.current);
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [timeoutBeforeCollectingRefs]);
  const mainGesture = panGesture.onBegin(event => {
    'worklet';

    const keys = Object.keys(loadedRefs);
    for (let i = 0; i < keys.length; i++) {
      const key = keys[i];
      const touchableItem = loadedRefs[key];
      const isPointInPath = touchableItem === null || touchableItem === void 0 ? void 0 : touchableItem.isPointInPath(event);
      if (isPointInPath && touchableItem !== null && touchableItem !== void 0 && touchableItem.onStart) {
        var _touchableItem$onStar;
        activeKey.value = [`${key}__${event.handlerTag}`];
        (_touchableItem$onStar = touchableItem.onStart) === null || _touchableItem$onStar === void 0 ? void 0 : _touchableItem$onStar.call(touchableItem, event);
      }
    }
  }).onUpdate(event => {
    'worklet';

    var _activatedKey$split, _touchableItem$onActi;
    const activatedKey = activeKey.value.find(key => key.includes(event.handlerTag.toString()));
    if (!activatedKey) {
      return;
    }
    const indexedKey = (_activatedKey$split = activatedKey.split('__')) === null || _activatedKey$split === void 0 ? void 0 : _activatedKey$split[0];
    if (!indexedKey) {
      return;
    }
    const touchableItem = loadedRefs[indexedKey];
    return touchableItem === null || touchableItem === void 0 ? void 0 : (_touchableItem$onActi = touchableItem.onActive) === null || _touchableItem$onActi === void 0 ? void 0 : _touchableItem$onActi.call(touchableItem, event);
  }).onFinalize(event => {
    'worklet';

    var _activatedKey$split2, _touchableItem$onEnd;
    const activatedKey = activeKey.value.find(key => key.includes(event.handlerTag.toString()));
    if (!activatedKey) {
      return;
    }
    const indexedKey = (_activatedKey$split2 = activatedKey.split('__')) === null || _activatedKey$split2 === void 0 ? void 0 : _activatedKey$split2[0];
    if (!indexedKey) {
      return;
    }
    const touchableItem = loadedRefs[indexedKey];
    activeKey.value = activeKey.value.filter(key => !key.includes(event.handlerTag.toString()));
    return touchableItem === null || touchableItem === void 0 ? void 0 : (_touchableItem$onEnd = touchableItem.onEnd) === null || _touchableItem$onEnd === void 0 ? void 0 : _touchableItem$onEnd.call(touchableItem, event);
  });
  (0, _react.useEffect)(() => {
    return () => {
      touchableRefs.value = {};
    };
  }, [touchableRefs]);
  return /*#__PURE__*/_react.default.createElement(_reactNativeGestureHandler.GestureDetector, {
    gesture: mainGesture
  }, /*#__PURE__*/_react.default.createElement(_reactNativeSkia.Canvas, props, /*#__PURE__*/_react.default.createElement(_context.TouchHandlerContext.Provider, {
    value: touchableRefs
  }, children)));
};
exports.Canvas = Canvas;
//# sourceMappingURL=canvas.js.map