"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useGestureHandler = void 0;
var _react = require("react");
const useGestureHandler = gestureHandlers => {
  const {
    onStart,
    onActive,
    onEnd
  } = gestureHandlers;
  const handleStart = (0, _react.useCallback)(touchInfo => {
    'worklet';

    if (!onStart) return;
    return onStart(touchInfo);
  }, [onStart]);
  const handleActive = (0, _react.useCallback)(extendedTouchInfo => {
    'worklet';

    if (!onActive) return;
    return onActive(extendedTouchInfo);
  }, [onActive]);
  const handleEnd = (0, _react.useCallback)(extendedTouchInfo => {
    'worklet';

    if (!onEnd) return;
    return onEnd(extendedTouchInfo);
  }, [onEnd]);
  return {
    onStart: handleStart,
    onActive: handleActive,
    onEnd: handleEnd
  };
};
exports.useGestureHandler = useGestureHandler;
//# sourceMappingURL=use-gesture-handler.js.map