"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRoundedRectPath = exports.getRectPath = void 0;
var _reactNativeSkia = require("@shopify/react-native-skia");
const getRectPath = params => {
  'worklet';

  const skPath = _reactNativeSkia.Skia.Path.Make();
  if ('rect' in params) {
    const {
      rect
    } = params;
    skPath.addRect(rect);
    return skPath;
  }
  const {
    x,
    y,
    width,
    height
  } = params;
  skPath.addRect(_reactNativeSkia.Skia.XYWHRect(x, y, width, height));
  return skPath;
};
exports.getRectPath = getRectPath;
const getRoundedRectPath = params => {
  'worklet';

  const {
    r
  } = params;
  const skPath = _reactNativeSkia.Skia.Path.Make();
  if ('rect' in params) {
    const {
      rect
    } = params;
    skPath.addRRect(_reactNativeSkia.Skia.RRectXY(rect, r, r));
    return skPath;
  }
  const {
    x,
    y,
    width,
    height
  } = params;
  const roundedRect = _reactNativeSkia.Skia.RRectXY(_reactNativeSkia.Skia.XYWHRect(x, y, width, height), r, r);
  skPath.addRRect(roundedRect);
  return skPath;
};
exports.getRoundedRectPath = getRoundedRectPath;
//# sourceMappingURL=get-rect-path.js.map