import { useCallback } from 'react';
const useGestureHandler = gestureHandlers => {
  const {
    onStart,
    onActive,
    onEnd
  } = gestureHandlers;
  const handleStart = useCallback(touchInfo => {
    'worklet';

    if (!onStart) return;
    return onStart(touchInfo);
  }, [onStart]);
  const handleActive = useCallback(extendedTouchInfo => {
    'worklet';

    if (!onActive) return;
    return onActive(extendedTouchInfo);
  }, [onActive]);
  const handleEnd = useCallback(extendedTouchInfo => {
    'worklet';

    if (!onEnd) return;
    return onEnd(extendedTouchInfo);
  }, [onEnd]);
  return {
    onStart: handleStart,
    onActive: handleActive,
    onEnd: handleEnd
  };
};
export { useGestureHandler };
//# sourceMappingURL=use-gesture-handler.js.map