import React from 'react';
import type { Vector } from '@shopify/react-native-skia';
import type { GestureStateChangeEvent, GestureUpdateEvent, PanGestureHandlerEventPayload } from 'react-native-gesture-handler';
export type TouchableHandlerContextType = {
    value: Record<string, {
        onStart: (touchInfo: GestureStateChangeEvent<PanGestureHandlerEventPayload>) => void;
        onActive: (touchInfo: GestureUpdateEvent<PanGestureHandlerEventPayload>) => void;
        onEnd: (touchInfo: GestureStateChangeEvent<PanGestureHandlerEventPayload>) => void;
        isPointInPath: (point: Vector) => boolean;
    }>;
};
declare const TouchHandlerContext: React.Context<TouchableHandlerContextType>;
declare const useTouchHandlerContext: () => TouchableHandlerContextType;
export { TouchHandlerContext, useTouchHandlerContext };
//# sourceMappingURL=context.d.ts.map