import { type SkPath } from '@shopify/react-native-skia';
import type { GestureStateChangeEvent, GestureUpdateEvent, PanGestureHandlerEventPayload } from 'react-native-gesture-handler';
import { SharedValue } from 'react-native-reanimated';
export type TouchableHandlerProps = {
    onStart: (touchInfo: GestureStateChangeEvent<PanGestureHandlerEventPayload>) => void;
    onActive: (touchInfo: GestureUpdateEvent<PanGestureHandlerEventPayload>) => void;
    onEnd: (touchInfo: GestureStateChangeEvent<PanGestureHandlerEventPayload>) => void;
    touchablePath: SkPath | SharedValue<SkPath>;
};
type WithTouchableHandlerProps<T> = T & Partial<TouchableHandlerProps>;
export declare const getSkiaPath: (key: string, props: any) => any;
declare const withTouchableHandler: <T>(Component: (props: WithTouchableHandlerProps<T>) => JSX.Element, componentName?: string) => ({ onStart: onStartProp, onActive: onActiveProp, onEnd: onEndProp, touchablePath, ...props }: WithTouchableHandlerProps<T>) => JSX.Element;
export { withTouchableHandler };
//# sourceMappingURL=with-touchable-handler.d.ts.map